(function(){
	var AF = {};

	// -------------------------------------------------------------------------------
	// STATICS
	// -------------------------------------------------------------------------------

	AF.reader = null; //this is set automatically when Reader is loaded

	AF.directives = {}; //filled by the directives defined in template.json
	AF.widgets = {};
	AF.enrichments = {};

	// -------------------------------------------------------------------------------
	// ERRORS
	// -------------------------------------------------------------------------------

	AF.curlError = function (error) {
		//console.error("curlError:" , error.message);
	};
	
	AF.parseError = function(error){
		//console.error("parseError:" , error);
	};

	
	AF.urlParams = (function (){
		var qs = document.location.search;
		qs = qs.split("+").join(" ");

		var params = {}, tokens,
			re = /[?&]?([^=]+)=([^&]*)/g;

		while (tokens = re.exec(qs)) {
			params[decodeURIComponent(tokens[1])]
				= decodeURIComponent(tokens[2]);
		}

		return params;
	})();
	
	AF.isTouchDevice = !!('ontouchstart' in window); // works on most browsers 
						//|| !!('onmsgesturechange' in window); // works on ie10 --> false positive on desktop. TODO: find a solution for Surface 
	AF.mousedown = AF.isTouchDevice ? "touchstart" : "mousedown";
	AF.mouseup = AF.isTouchDevice ? "touchend" : "mouseup";
	AF.mousemove = AF.isTouchDevice ? "touchmove" : "mousemove";
	
	AF.getEventPosObject = function(event){
		if(AF.isTouchDevice){
			var touches = event.touches || event.originalEvent.touches; 
			return touches[0];
		}else{
			return event;
		}
	};
	
	
	window.AF = AF;

    AF.notificatorHandler = null;
	
})();
