define( function(){
	
	
	var Select = function(){
		
	};

	Select.prototype.init = function($element){
		this.$element = $element;
		
		//TODO: articles if needed
		this.dataType = this.$element.attr("select-dataType") || "section";
		
		
		var dataArray = AF.reader.models.issue.sections;
		var selectHtml = ['<select>'];
		for(var i=0 ; i<dataArray.length ; i++){
			selectHtml.push('<option value="',i,'">',dataArray[i].texts.title,'</option>');
		}
		selectHtml.push('</select>');
		selectHtml = selectHtml.join('');
		
		this.$select = $(selectHtml);
		this.$select.css({
			opacity: 0,
			position: "absolute",
			left: "0px",
			right: "0px",
			width: "100%",
			height: "100%"
		});
		this.$select.appendTo(this.$element);
		this.$select.change($.proxy(this._onSelect,this));
	};
	

	Select.prototype.applyModelChanges = function(changeMap){
		if(!changeMap || changeMap.section){
			var index = AF.reader.state.sectionIndex;
			this.$select.val(index);
		}
		return false;
	};

	Select.prototype.update = function(){
		
	};

	Select.prototype._onSelect = function(event){
		var index = this.$select.val();
		if(index != AF.reader.state.sectionIndex ){
			AF.reader.selectArticle(0 , index);
		}
	};

	Select.order = 0;
	AF.directives.select = Select;
	
});