/**
 * Objects Helper.
 */
(function(){
	
	
	
	var baseWidth = 200 , baseHeight = 80 , startX = 80 , startY = 0;
	
	var initialized = false,
		$div , $console , _tempBuffer = [];
	
	var _init = function(){
		if(!initialized){
			initialized = true;
			
			$div = jQuery("<div id='af-consoleDiv'></div>")
				.css({
					"background-color": "rgb(255,200,255)",
					"-webkit-overflow-scrolling" : "touch" ,
					position: "absolute",
					"z-index": 100000,
					top: startY+"px",
					left: startX+"px",
					"overflow-x": "hidden",
					"overflow-y": "auto",
					width: baseWidth+"px",
					"font-size": 11+"px",
					height: baseHeight+"px"
				}).click(function(){
					if($div.css("width")== baseWidth+"px"){
						$div.css("width","auto");
						$div.css("height","auto");
						$div.css("bottom","10px");
						$div.css("right","10px");
					}else{
						$div.css("bottom","");
						$div.css("right","");
						$div.css("left","10");
						$div.css("width", baseWidth+"px");
						$div.css("height", baseHeight+"px");
					}
				});

			$console = jQuery("<div></div>")
				.appendTo($div);
			
			var $button = jQuery('<input type="submit" value="clear" style="margin-left: 80px"></input>')
				.click(function(event){
					$console.html("");
					event.stopImmediatePropagation();
				})
				.appendTo($div);
			
			
			
			setInterval( function(){
				if(_tempBuffer && _tempBuffer.length>0){
					var s = _tempBuffer.join("<br>");
					jQuery("<div></div>")
						.html(s)
						.appendTo($console);

					$div.scrollTop( $console[0].scrollHeight );
					
					_tempBuffer = [];
				}
			},1000);

			//touchScroll('ofConsoleDiv');
			$(function(){
				//append div to document when it is loaded
				$div.appendTo("body");
			});
		}
	};
	
	var log = function(args__){
		if(!initialized){ 
			_init(); 
		}
		var string = "";
		for(var i=0 ; i<arguments.length ; i++){
			string = string + " " + arguments[i];
		}
		_tempBuffer.push(string);
	};



	function isTouchDevice() {
		//if ((navigator.userAgent.match(/android 3/i)) || (navigator.userAgent.match(/honeycomb/i))) return false;
		try {
			document.createEvent("TouchEvent");
			return true;
		} catch (e) {
			return false;
		}
	}
	
	
	if(isTouchDevice() ){
		if(typeof console !== "undefined") {
			console.log = log;
		}
	}

	
	/*
	function isTouchDevice() { 
		if ((navigator.userAgent.match(/android 3/i)) || (navigator.userAgent.match(/honeycomb/i))) return false;
		try {
			document.createEvent("TouchEvent");
			return true;
		} catch (e) {
			return false;
		}
	}

	function touchScroll(id) {
		if (isTouchDevice()) {
			var el = document.getElementById(id);
			var scrollStartPosY = 0;
			var scrollStartPosX = 0;
			document.getElementById(id).addEventListener("touchstart", function(event) {
				scrollStartPosY = this.scrollTop + event.touches[0].pageY;
				scrollStartPosX = this.scrollLeft + event.touches[0].pageX; //event.preventDefault();
			}, false);
			document.getElementById(id).addEventListener("touchmove", function(event) { // These if statements allow the full page to scroll (not just the div) if they are 
				// at the top of the div scroll or the bottom of the div scroll 
				// The -5 and +5 below are in case they are trying to scroll the page sideways 
				// but their finger moves a few pixels down or up. The event.preventDefault() function 
				// will not be called in that case so that the whole page can scroll. 
				if ((this.scrollTop < this.scrollHeight - this.offsetHeight && this.scrollTop + event.touches[0].pageY < scrollStartPosY - 5) || (this.scrollTop != 0 && this.scrollTop + event.touches[0].pageY > scrollStartPosY + 5)) event.preventDefault();
				if ((this.scrollLeft < this.scrollWidth - this.offsetWidth && this.scrollLeft + event.touches[0].pageX < scrollStartPosX - 5) || (this.scrollLeft != 0 && this.scrollLeft + event.touches[0].pageX > scrollStartPosX + 5)) event.preventDefault();
				this.scrollTop = scrollStartPosY - event.touches[0].pageY;
				this.scrollLeft = scrollStartPosX - event.touches[0].pageX;
			}, false);
		}
	}
	*/
	
})();
